package apis

import (
	"duoduo/apis/bizhi/models"
	"duoduo/models/bizhi"
	"duoduo/models/mysqlBz"
	"duoduo/tools"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
)

func Download(c *gin.Context) {
	var inData models.InsertDownloadRequest
	var sqlData bizhi.Download
	var bizhi mysqlBz.BiZhi

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}
	bizhi.ID = inData.BiZhiId
	res, err := bizhi.BiZhiDes()
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}
	sqlData.OpenID = inData.OpenId
	sqlData.Url = res.Url
	sqlData.CreateTime = tools.GetCurrntTimeStr()
	sqlData.BizhiID = inData.BiZhiId
	err = sqlData.Insert()
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}
	app.OK(c, nil, "成功")
}
