package apis

import (
	"duoduo/apis/bizhi/models"
	"duoduo/models/bizhi"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
)

func LabelList(c *gin.Context) {
	var outData models.LabelListResponse
	var outDataList []models.LabelListResponse
	var sqlData bizhi.Label

	labelData, err := sqlData.GetLabelList()
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	for i := 0; i < len(labelData); i++ {
		var config models.Config
		config.Content = labelData[i].Label
		config.Size = "large"
		config.FontColor = "#04885c"
		config.Plain = true
		config.Select = false
		config.Shape = "square"
		outData.Config = append(outData.Config, config)
	}
	outData.Title = "标签"
	outDataList = append(outDataList, outData)
	app.OK(c, outDataList, app.Success)

}

func LabelInert(c *gin.Context) {
	var inData models.LabelInsertRequest

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}
	var sqlData bizhi.Label
	sqlData.Label = inData.Label

	err = sqlData.Insert()
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}
	app.OK(c, nil, app.Success)
}
