package apis

import (
	"duoduo/apis/bizhi/models"
	"duoduo/models/bizhi"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
)

func ScoreLogList(c *gin.Context) {
	var inData models.ScoreLogListRequest

	var score bizhi.ScoreLog

	var pageSize = 10
	var pageIndex = 1

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	if inData.PageSize != 0 {
		pageSize = inData.PageSize
	}
	if inData.PageIndex != 0 {
		pageIndex = inData.PageIndex
	}

	score.OpenID = inData.OpenId
	scoreVal, count, err := score.ScoreLogList(pageSize, pageIndex)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}

	app.PageOK(c, scoreVal, count, pageIndex, pageSize, app.Success)
}
