package bizhi

import (
	"duoduo/apis/bizhi/apis"
	"github.com/gin-gonic/gin"
)

//壁纸下载
func InitBiZhiRouter(engine *gin.RouterGroup) {
	v1 := engine.Group("v1")
	{
		v1.POST("/upload", apis.Upload)                      //下载图片
		v1.POST("/round", apis.RondPicture)                  //随机图片
		v1.POST("/set.user", apis.OpenIdSet)                 //用户注册
		v1.POST("/get.score", apis.GetUserScore)             //校验积分
		v1.POST("/sub.score", apis.SubUserScore)             //+-积分
		v1.POST("/score.list", apis.ScoreLogList)            //积分消费记录
		v1.POST("/openid.list", apis.GetUserList)            //邀请用户列表
		v1.POST("/bizhi.label", apis.PictureLabel)           //壁纸审核
		v1.POST("/label.list", apis.LabelList)               //标签
		v1.POST("/label.insert", apis.LabelInert)            //插入标签
		v1.POST("/bizhi.update", apis.PictureLabelUpdate)    //更新标签
		v1.POST("/bizhi.group", apis.PictureGroup)           //获取组图
		v1.POST("/update.score", apis.UpdateUser)            //更新用户头像昵称
		v1.POST("/insert.collection", apis.InsertCollection) //插入收藏
		v1.POST("/del.collection", apis.DelCollection)       //删除收藏
		v1.POST("/insert.download", apis.Download)           //插入下载
		v1.POST("/collection.list", apis.ListCollection)     //获取用户收藏信息
		v1.POST("/search", apis.Search)                      //图片检索
	}
}
