package qiniu

import (
	"duoduo/conf"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
	"github.com/qiniu/go-sdk/v7/auth/qbox"
	"github.com/qiniu/go-sdk/v7/storage"
)

func ClientVoucher(c *gin.Context) {

	confIni, err := conf.ConnIni()
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	bucket := confIni.MustValue("ly-qn", "bucket")
	putPolicy := storage.PutPolicy{
		Scope: bucket,
	}
	mac := qbox.NewMac(confIni.MustValue("ly-qn", "access_key"), confIni.MustValue("ly-qn", "secret_key"))
	upToken := putPolicy.UploadToken(mac)

	app.OK(c, upToken, app.Success)
}
