package petsLy

import (
	"github.com/shopspring/decimal"
)

type PetsCreateRequest struct {
	OpenId              string          `json:"open_id" binding:"required"`
	Name                string          `json:"name" binding:"required"`                  // 昵称
	Pet                 string          `json:"pet" binding:"required"`                   // 品种
	Age                 string          `json:"age" binding:"required"`                   // 年龄  '0-3个月','3-6个月','6-9个月','小于1岁','小于2岁','小于3岁','大于3岁'
	Sex                 string          `json:"sex" binding:"required"`                   // 性别 MM GG
	PetStatus           int             `json:"pet_status" binding:"required"`            // 1-流浪 2-家养 3-收养所
	PetDes              string          `json:"pet_des" binding:"required"`               // 宠物详细种类
	IsSterilization     int             `json:"is_sterilization" binding:"required"`      // 绝育状态:1-是 2-否 3-不确认
	IsExpellingParasite int             `json:"is_expelling_parasite" binding:"required"` // 驱虫状态：1-是 2-否 3-不确认
	IsImmune            int             `json:"is_immune" binding:"required"`             // 免疫状态：1-是 2-否 3-不确认
	IsFee               int             `json:"is_fee" binding:"required"`                // 1-免费 2-押金 3-有偿
	Deposit             decimal.Decimal `json:"deposit"`                                  // 押金
	DepositDate         string          `json:"deposit_date"`                             // 押金到期时间
	Amount              decimal.Decimal `json:"amount" `                                  // 金额
	Province            string          `json:"province" binding:"required"`              // 省
	City                string          `json:"city" binding:"required"`                  // 市
	Area                string          `json:"area" binding:"required"`                  // 区
	PetInfo             string          `json:"pet_info" binding:"required"`              // 宠物信息
	AdoptInfo           string          `json:"adopt_info" binding:"required"`            // 领养要求
	Pictures            []string        `json:"pictures"`                                 // 图片url
}
