package shanghu

import (
	orm "duoduo/database"
	"time"
)

type PayCallbackLog struct {
	ID           int64     `gorm:"column:id;type:bigint(20);primary_key;AUTO_INCREMENT" json:"id"`
	CallBackLog  string    `gorm:"column:call_back_log;type:text" json:"call_back_log"`
	ErrLog       string    `gorm:"column:err_log;type:varchar(255)" json:"err_log"`                   // 处理失败原因
	OutTradeNo   string    `gorm:"column:out_trade_no;type:varchar(255)" json:"out_trade_no"`         // 交易id
	ThirdTradeNo string    `gorm:"column:third_trade_no;type:varchar(255)" json:"third_trade_no"`     // 微信交易id
	CreateBy     int64     `gorm:"column:create_by;type:bigint(20)" json:"create_by"`                 // 创建者
	UpdateBy     int64     `gorm:"column:update_by;type:bigint(20)" json:"update_by"`                 // 更新者
	CreatedAt    time.Time `gorm:"column:created_at;type:datetime(3)" json:"created_at"`              // 创建时间
	UpdatedAt    time.Time `gorm:"column:updated_at;type:datetime(3)" json:"updated_at"`              // 最后更新时间
	DeletedAt    time.Time `gorm:"column:deleted_at;type:datetime(3);default:null" json:"deleted_at"` // 删除时间
}

func (m *PayCallbackLog) TableName() string {
	return "pay_callback_log"
}

func (u *PayCallbackLog) Create() (PayCallbackLog, error) {
	var doc PayCallbackLog
	var err error

	doc = *u
	err = orm.ShMysql.Table(u.TableName()).Create(&doc).Error
	if err != nil {
		return doc, err
	}

	return doc, nil
}

func (m *PayCallbackLog) UpdateMerchant() error {

	if err := orm.ShMysql.Table(m.TableName()).Model(&m).Where("third_trade_no = ? ", m.ThirdTradeNo).Updates(
		map[string]interface{}{
			"err_log":    m.ErrLog,
			"updated_at": time.Now()}).Error; err != nil {
		return err
	}

	return nil
}
